//	$Id: allocator.cpp,v 1.1 2001/11/22 13:42:41 sugiura Exp $
/*
 *	allocator.cpp
 *	Allocator NX̎
 */

/*
	slab allocator

	v[F
		1) 2^n ̃TCỸmہB
		2) k_min <= k < n Ȃ k ɂ 2^k ̃TCỸNXg
		   pӂB
		3) 2^(n-1) x 2 ̃ubN n-1 Ԗڂ̃NXgɒǉB

	AP[gF
		1) AP[gvTCY傫ł߂ 2^k  k ߂B
		   AAk_min 菬 k = k_min ƂB
		2) k Ԗڂ̃NXgɊɗvf΂XgOB
		2')k Ԗڂ̃NXgɗvfȂ΁Ak+1 ` n-1 ̓ōł
		   łȂXg(m ԖڂƂ)vfOB
		   ̗vf 2^k x 2, 2^(k+1), ..., 2^(m-1) ̃ubNɕA
		   2^k ̂P̗vfȊONXgɂȂB
		3) OubÑւ̃|C^ԂB

	fAP[gF
		1) nꂽ|C^ɑΉ郁ubNTB
		2) 1) ŌubN 2^k TCỸubNƂƁÃubN
		   ƃyAɂȂĂubNgpĂ邩ǂ𒲂ׂB
		   gpł k Ԗڂ̃NXgɂ̂܂܂ȂB
		   gp(NXgɂȂĂ)ł΁AQ𕹂
		   2^(k+1) TCỸubNƂĈA2) ̏JԂB

 */

#include "allocator.h"

Allocator::Allocator()
{
}

Allocator::~Allocator()
{
}

void*
Allocator::alloc(int size)
{
}

void
Allocator::free(void* ptr)
{
}

MemPage*
Allocator::createNewPage()
{
	MemPage* ret = this->morecore(sizeof(MemPage) + PAGE_SIZE);
	if (ret != NULL) {
		::ZeroMemory(ret, sizeof(MemPage));
		MemBlock* first = register_latterhalf(ret,
								(MemBlock*)((BYTE*)ret + sizeof(MemPage)),
								PAGE_SIZE_SHIFT - 1);
		// ŏ͕ŏ̃y[Wo^
		first->m_next = ret->m_free_blocks[PAGE_SIZE_SHIFT - 1];
		ret->m_free_blocks[PAGE_SIZE_SHIFT - 1] = first;
	}
	return ret;
}

MemBlock*
Allocator::register_latterhalf(MemPage* page, MemBlock* block, DWORD shift)
{
	DWORD size = MIN_BLOCK_SIZE << shift;
	MemBlock* second = (MemBlock*)((BYTE*)block + size);
	block->m_magic = second->m_magic = MEMPAGE_MAGIC;
	block->m_shift = second->m_shift = shift;
	block->m_flags  = FIRST_BLOCK;
	second->m_flags = SECOND_BLOCK;
	second->m_next = page->m_free_blocks[shift];
	page->m_free_blocks[shift] = second;
	return block;
}

BOOL
Allocator::register_block(MemPage* page, MemBlock* block)
{
	if (block->m_magic != MEMBLOCK_MAGIC) return FALSE;

	if (block->m_shift == PAGE_SHIFT_SIZE - 1) {
		block->m_next = page->m_free_blocks[PAGE_SHIFT_SIZE - 1];
		page->m_free_blocks[PAGE_SHIFT_SIZE - 1] = block;
		block->m_flags &= ~MEMBLOCK_USED;
		return TRUE;
	}

	MemBlock* pair;
	if (block->m_flags & FIRST_BLOCK) {
		pair = (MemBlock*)((BYTE*)block + block->m_size);
		if (pair->m_magic != MEMBLOCK_MAGIC) return FALSE;
		if ((pair->m_flags & MEMBLOCK_USED) == 0) {
			// remove pair from link list
			block->m_shift++;
			block->m_flags &= ~MEMBLOCK_USED;
			return TRUE;
		}
	} else {
		pair = (MemBlock*)((BYTE*)block - block->m_size);
		if (pair->m_magic != MEMBLOCK_MAGIC) return FALSE;
		if ((pair->m_flags & MEMBLOCK_USED) == 0) {
		}
	}

}

