// $Id: ddeserv.h,v 1.2 2007/03/05 13:04:54 sugiura Exp $
/*
 *	ddeserv.h
 *	DDE T[o{̂̃NX`
 */

#ifndef DENGAKUSERVER_CLASSES_DDESERVER
#define DENGAKUSERVER_CLASSES_DDESERVER

#include "session.h"
#include "resource.h"
#include "ddeobjs.h"
#include "convdata.h"
#include "cmdname.h"
#include "ctrlname.h"
#include "file.h"
#include "common.h"

class DDEServerInfo;
class CmdLineParser;

//	Ƃ͂ƂƂė~ :-< l
//	HDDE_FALSE, HDDE_NULL, HDDE_FNOTPROCESSED (= 0) 
//	ȂĂ͌Ȃǁc(^^;
#define	HDDE_TRUE			(reinterpret_cast<HDDEDATA>(TRUE))
#define	HDDE_FALSE			(reinterpret_cast<HDDEDATA>(FALSE))
#define	HDDE_FACK			(reinterpret_cast<HDDEDATA>(DDE_FACK))
#define	HDDE_FNOTPROCESSED	(reinterpret_cast<HDDEDATA>(DDE_FNOTPROCESSED))
#define	HDDE_NULL			(static_cast<HDDEDATA>(NULL))

//	bZ[Wnh̃p[^Xg
#define MH_ARGS (const HCONV, const HSZ, const HSZ, const HDDEDATA)

/*
	DDE T[o̎̂ƂȂNX

	DdeServer NX̓NXoƃNX\bĥ݂琬B
*/
class DdeServer {
public:
	//	T[ȍ/IAJn/~
	static BOOL init(DDEServerInfo&); // DDE T[ȍ
	static BOOL uninit(); // DDE T[ȍI

	//	Ԏ擾\bh
	static BOOL isActive() { return m_bActive; }
	static BOOL isStrictEmulation() { return m_bStrictEmulation; }

	//	gsbNT|[gꂽ̂ǂ
	static BOOL isSupportedTopic(const HSZ);

	//	ol擾\bh
	static DWORD getddeInst() { return m_ddeInst; }
	static HINSTANCE gethInst() { return m_hInstance; }
	static HWND gethwndDlg() { return m_hwndDlg; }
	static const DdeString& getServiceName()
	{
		return *m_pdsServiceName;
	}

	//	ConvData NX\bh
	static int getConvNum()
	{
		return m_ConvDataList.itemNum();
	}
	static int addConvData(const HCONV hconv, const HSZ hszTn);
	static void deleteConvData(ConvData* pCd = NULL);
	static ConvData* getConvData(const HCONV);
	static ConvData* isStoredCD(const HSZ);

	static void notifyPostAdvise(ConvData* pCd);

	//	DdemlCallback ֐̃bZ[Wnh̎(O)
	static HDDEDATA regist MH_ARGS;
	static HDDEDATA unregist MH_ARGS;
	static HDDEDATA connect MH_ARGS;
	static HDDEDATA connectconfirm MH_ARGS;
	static HDDEDATA error MH_ARGS;
	static HDDEDATA disconnect MH_ARGS;
	static HDDEDATA execute MH_ARGS;
	static HDDEDATA request MH_ARGS;
	static HDDEDATA poke MH_ARGS;
	static HDDEDATA advstart MH_ARGS;
	static HDDEDATA advstop MH_ARGS;
	static HDDEDATA advreq MH_ARGS;

	//	DdemlCallback ֐̃bZ[Wnh̎(OL)
	static HDDEDATA lregist MH_ARGS;
	static HDDEDATA lunregist MH_ARGS;
	static HDDEDATA lconnect MH_ARGS;
	static HDDEDATA lconnectconfirm MH_ARGS;
	static HDDEDATA lerror MH_ARGS;
	static HDDEDATA ldisconnect MH_ARGS;
	static HDDEDATA lexecute MH_ARGS;
	static HDDEDATA lrequest MH_ARGS;
	static HDDEDATA lpoke MH_ARGS;
	static HDDEDATA ladvstart MH_ARGS;
	static HDDEDATA ladvstop MH_ARGS;
	static HDDEDATA ladvreq MH_ARGS;

	static BOOL isLogging(); // OLǂ

private:
	static BOOL m_bActive; // T[o쒆ǂ
	static BOOL m_bStrictEmulation; // }NT[o݊[hǂ
	static HINSTANCE m_hInstance; // W[CX^Xnh
	static DWORD m_ddeInst; // DDE T[õCX^Xnh
	static HWND m_hwndDlg; // CEBhẼnh
	static Auto_Ptr<DdeString> m_pdsServiceName; // {T[rX
	static const StringBuffer m_sbTopicNames; // gsbÑXg
	static LinkList<ConvData> m_ConvDataList; // DDE ʐMf[^̃Xg
	static Auto_Ptr<File> m_pfLogFile; // Ot@C
	static Auto_Ptr<StringBuffer> m_psbLogFileName; // Ot@C

	//	R}h->֐AhX擾郁\bh
	static PFNDDECMD_EXECUTE getExecCmd(const StringBuffer& name);
	static PFNDDECMD_REQUEST getReqCmd(const StringBuffer& name);
	static PFNDDECMD_POKE getPokeCmd(const StringBuffer& name);

	//	Ot@C֘Ã\bh
	static BOOL startLog(const StringBuffer*); // Ot@C̍쐬
	static void stopLog(); // Ot@C
	static void writeLog(LPCSTR); // OɃf[^
	//	̒ʐM̌ʂOɏ
	static void writeLog(const HCONV, LPCSTR);
	static void writeArgvToLog(const HCONV, CmdLineParser&, StringBuffer&);
};

#endif

