//	$Id: main.cpp,v 1.10 2011/01/07 16:08:38 sugiura Exp $
/*
 *	main.cpp
 *	cyT[o{
 */

#include "resource.h"
#include "common.h"
#include "ddeserv.h"
#include "ddesinfo.h"
#include "misc.h"

#include <commctrl.h>

/*
    R}hC߁DDEServerInfo\̂ւ̃f[^̊i[s֐

	T|[gĂR}hCIvV͈ȉ̒ʂ
	    /h                  :   ACRB
	    /e                  :   }NT[o݊[h
	    /s ServiceName      :   {T[rX ServiceName ɕς
	    /l [LogFileName]    :   T[õO擾

    st@C macserv.exe ꍇA܂͊{T[rX
      "HideMacroServer" ꍇA}NT[o݊[hLɂȂB
*/
static BOOL
ParseCmdLine(DDEServerInfo& dsi)
{
//	Windows vOł __argc, __argv ŃR\[vÔ悤
//	R}hC擾łc炵(^^;B
//	ŁA(^^;̂ŕʖ`
#ifdef __GNUC__
extern int _argc;
extern char** _argv;
#define ac _argc
#define av _argv
#else
#define	ac __argc
#define	av __argv
#endif
//	sȃp[^̃`FbN
	if (ac < 1) return FALSE;

//	tpX̎st@C擾
	dsi.m_sbModuleName.resize(MAX_PATH);
	::GetModuleFileName(dsi.m_hInst,dsi.m_sbModuleName.getBufPtr(),MAX_PATH);
	if (dsi.m_sbModuleName.length() <= 0) return FALSE;

//	st@C "macserv.exe" Ȃ}NT[o݊[hnmɂ
	LPCSTR ptr = lstrrchr((LPCSTR)dsi.m_sbModuleName,'\\');
	if (ptr != NULL && lstrcmpi(++ptr,GetServerString(SVR_STR_MSEXENAME)) == 0)
		dsi.m_bStrictEmulation = TRUE;

//	IvV̉
	//	/s, /l IvV̎̕i[obt@ւ̃|C^
	StringBuffer* ppopt = NULL;
	for (char** pptr = av; *pptr != NULL; pptr++) {
		switch (**pptr) {
		case '/':	//	IvV("/"  "-" gp\)
		case '-':
			switch (*++*pptr) {
			case 'h':	//	ACRB
				dsi.m_bHideIcon = TRUE;
				ppopt = NULL;
				break;
			case 's':	//	{T[rX̐ݒ
				if (!dsi.m_bStrictEmulation) ppopt = &dsi.m_sbServiceName;
				break;
			case 'l':	//	T[õO
				if (!dsi.m_psbServerLogFileName) {
					try {
						dsi.m_psbServerLogFileName
							= new StringBuffer(nullStr);
					} catch (...) {
						//	no operation.
					}
				}
				ppopt = dsi.m_psbServerLogFileName;
				break;
			case 'e':	//	}NT[o݊[hnm
				dsi.m_bStrictEmulation = TRUE;
				ppopt = NULL;
				break;
			default:	//	ߕs\ȃIvV
				ppopt = NULL;
			}
			//	/s, /l IvVw莞 "/sServicename" ̗l
			//	Ăꍇւ̑Ώ
			if (ppopt != NULL && *++*pptr) {
				*ppopt = *pptr;
				ppopt = NULL;
			}
			break;

		default:	//	"/?"("-?") łȂ̏ꍇ
			if (ppopt != NULL) {
				//	O "/s" ܂ "/l" ꍇւ̑Ώ
				*ppopt = *pptr;
				ppopt = NULL;
			}
		}
	}

	//	{T[rX̐ݒ
	if (dsi.m_bStrictEmulation)
		//	}NT[o̊{T[rX(="HideMacroServer")
		dsi.m_sbServiceName = GetServerString(SVR_STR_MSSERVICENAME);
	else if (dsi.m_sbServiceName.length() <= 0)
		//	ftHg̊{T[rX(="DengakuServer")ɐݒ
		dsi.m_sbServiceName = GetServerString(SVR_STR_DSSERVICENAME);

	//	ftHg̃Ot@C̐ݒ
	if (dsi.m_psbServerLogFileName != NULL &&
		dsi.m_psbServerLogFileName->length() <= 0) {
		StringBuffer& lfn = *dsi.m_psbServerLogFileName;
		lfn = dsi.m_sbModuleName;
		int sep = lfn.rfind((TCHAR)'\\');
		lfn.setlength(++sep);
		lfn.append(dsi.m_sbServiceName).append(".log");
	}

	//	~[ebNXIuWFNg̖O̐
	dsi.m_sbMutexName = GetServerString(SVR_STR_DSMUTEXNAME);
	dsi.m_sbMutexName.append(dsi.m_sbServiceName);

	//	CEBhẼ^Cg̐
	dsi.m_sbWndTitle = GetServerString(SVR_STR_SERVERNAME);
	dsi.m_sbWndTitle.append(" - ").append(dsi.m_sbServiceName);

	return TRUE;
}

//	CEBhE֐
static BOOL
InitMainWindow(DDEServerInfo* pdsi)
{
	//	EBhE^Cg̓o^
	::SetWindowText(pdsi->m_hwndMain,pdsi->m_sbWndTitle);

	//	AvAo[W
	StringBuffer name(GetServerString(SVR_STR_SERVERNAME),-1,16);
	name.append(" Ver.").append(GetServerString(SVR_STR_VERSION));
	::SetDlgItemText(pdsi->m_hwndMain,IDC_APPNAME,name);

	//	^XNgCɃACRo^\̂̏
	NOTIFYICONDATA* lptnid = &pdsi->m_NotifyIconData;
	lptnid->cbSize = sizeof(NOTIFYICONDATA);
	lptnid->hWnd = pdsi->m_hwndMain;
	lptnid->uID = 1;
	lptnid->uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
	lptnid->uCallbackMessage = WM_USER_MENU;	//	MainWndProc ւ MSG
	lptnid->hIcon = (HICON)::LoadImage(pdsi->m_hInst,
										MAKEINTRESOURCE(IDI_ICON),
										IMAGE_ICON,
										16,16,0);
	lstrcpy(lptnid->szTip,pdsi->m_sbWndTitle);

	//	EBhEʒɈړ
	RECT rectMain;
	GetWindowCenter(pdsi->m_hwndMain, ::GetDesktopWindow(), rectMain);
	::SetWindowPos(pdsi->m_hwndMain, HWND_TOPMOST,
				   rectMain.left, rectMain.top, 0, 0,
				   SWP_NOACTIVATE | SWP_NOREDRAW | SWP_NOSIZE | SWP_HIDEWINDOW);

	return TRUE;
}


/*
	CEBhẼEBhEvV[W

	Ă邱ƁF
		EACR̓o^()
		EDDE T[o̊Jn/I
		EACR̃bZ[W(WM_LBUTTONDBLCLK, WM_RBUTTONDOWN)̏
		Ej[̃bZ[W̏

*/
BOOL CALLBACK
MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	DDEServerInfo*
		pdsi = reinterpret_cast<DDEServerInfo*>(::GetWindowLongPtr(hWnd, DWLP_USER));

	switch (uMsg) {
	case WM_INITDIALOG:	//	CEBhȄ
		//	lParam : T[o̓\̂ւ̃|C^
		::SetWindowLongPtr(hWnd,DWLP_USER,lParam);
		pdsi = reinterpret_cast<DDEServerInfo*>(lParam);

		//	EBhEnh̓o^
		pdsi->m_hwndMain = hWnd;

		//	CEBhȄ{
		if (!InitMainWindow(pdsi)) {
			ErrorMessageBox(MSG_ERR_START);
			::DestroyWindow(hWnd);
			return TRUE;
		}

		//	^XNgCɃACRo^
		if (!pdsi->m_bHideIcon)
			::Shell_NotifyIcon(NIM_ADD,&pdsi->m_NotifyIconData);

		//	DDE T[o̊Jn
		if (!DdeServer::init(*pdsi)) {
			ErrorMessageBox(MSG_ERR_START);
			::DestroyWindow(hWnd);
		}
		return FALSE;


	case WM_COMMAND:	//	Rg[/j[̃bZ[W
		switch (LOWORD(wParam)) {
		case IDOK:	//	unjv{^ꂽ
			//	CEBhEĂщB
			::ShowWindow(hWnd,SW_HIDE);
			break;

		case IDM_ABOUT:	//	j[́ucyT[oɂāvIꂽ
			//	{T[rX\
			::SetDlgItemText(hWnd,IDC_SERVICENAME,pdsi->m_sbServiceName);
			//	݊mĂ DDE ʐM̐\
			::SetDlgItemInt(hWnd,IDC_CONVNUM,DdeServer::getConvNum(),FALSE);
			//	CEBhE\
			::SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,
							SWP_SHOWWINDOW|SWP_NOSIZE|SWP_NOMOVE);
			break;

		case IDM_HELP:		//	j[́uwvvIꂽ
		case IDC_SHOWHELP:	//	uwvv{^ꂽ
			{
				//	wvt@C̐
				StringBuffer buf(pdsi->m_sbModuleName);
				buf.setlength(buf.length()-3);
				buf.append("hlp");
				//	wv̌ďo
				::WinHelp(hWnd,buf,HELP_FINDER,0L);
			}
			break;

		case IDM_QUIT:	//	j[́uIvIꂽ
		case IDC_CLOSE:	//	uIv{^ꂽ
			//	I{^/j[ڂI
			::DestroyWindow(hWnd);
			break;

		}
		break;

	case WM_CLOSE:	//	IbZ[W
		::DestroyWindow(hWnd);
		break;

	case WM_DESTROY:	//	T[ȍI
		if (!pdsi->m_bHideIcon)
			::Shell_NotifyIcon(NIM_DELETE,&pdsi->m_NotifyIconData);
		if (!DdeServer::uninit()) ErrorMessageBox(MSG_ERR_STOP);
		::PostQuitMessage(0);
		break;

	case WM_USER_MENU:	//	^XNgCACR̃bZ[W
		switch (LOWORD(lParam)) {
		case WM_LBUTTONDBLCLK:	//	_uNbN
			//	CEBhE\
			::PostMessage(hWnd,WM_COMMAND,IDM_ABOUT,0L);
			break;

		case WM_RBUTTONDOWN:	//	ENbN
			{
				//	j[\
				POINT pt;
				::SetForegroundWindow(hWnd);
				::GetCursorPos(&pt);
				::TrackPopupMenu(
							::GetSubMenu(
									::LoadMenu(pdsi->m_hInst,
												MAKEINTRESOURCE(IDR_MENU)),
									0),
							TPM_RIGHTALIGN|TPM_RIGHTBUTTON,
							pt.x, pt.y, 0, hWnd, NULL);
			}
			break;
		}
		break;

	case WM_USER_DDE_STOP:	//	DDE ʐM/T[ȍI
		if (DdeServer::isActive()) {
			//	(ConvData*)lParam != NULL : ̒ʐM̏I
			//					   = NULL : SʐM̏I
			DdeServer::deleteConvData(reinterpret_cast<ConvData*>(lParam));
			if (!lParam) ::DestroyWindow(hWnd);	//	T[oI
		}
		break;

	case WM_USER_SHOWICON:	//	^XNgC̃ACR̕\/\̐ؑ
		if (static_cast<WPARAM>(pdsi->m_bHideIcon) != wParam) {
			pdsi->m_bHideIcon = wParam;
			::Shell_NotifyIcon(pdsi->m_bHideIcon ? NIM_DELETE : NIM_ADD,
								&pdsi->m_NotifyIconData);
		}
		break;

	case WM_USER_NOTIFYPOSTADV:	//	̃vZX DdePostAdvise() Ă
		DdeServer::notifyPostAdvise((ConvData*)lParam);
		break;

	default:
		return FALSE;

	}
	return TRUE;
}

#ifdef __GNUC__

static LPCSTR
	pszClassName = "DengakuServerClass",
	pszCaption = "cyT[oɂ",
	pszFontName = "lr oSVbN",
	pszOK = "OK",
	pszHelp = "wv",
	pszQuit = "I",
	pszTitle = "cy (ł񂪂) T[o  Ver.2.00",
	pszCopyRight = "Copyright(C) 1998-2002, M. Sugiura (sugiura@ceres.dti.ne.jp)",
	pszLabelConnect = "݂ DDE ʐM",
	pszLabelService = "T[rXF",
	pszLabelNumber  = "ʐMF";

#define CLASSNAME_SIZE (19 * sizeof(WORD))
#define CAPTION_SIZE   (10 * sizeof(WORD))
#define FONTNAME_SIZE  ( 9 * sizeof(WORD))
#define OK_SIZE        ( 3 * sizeof(WORD))
#define HELP_SIZE      ( 4 * sizeof(WORD))
#define QUIT_SIZE      ( 3 * sizeof(WORD))
#define TITLE_SIZE     (25 * sizeof(WORD))
#define COPYRIGHT_SIZE (61 * sizeof(WORD))
#define CONNECT_SIZE   (11 * sizeof(WORD))
#define SERVICE_SIZE   ( 7 * sizeof(WORD))
#define NUMBER_SIZE    ( 5 * sizeof(WORD))

#define DLGTEMPL_SIZE 1024 * 256

#define IDC_STATIC (WORD)(-1)

static LPWSTR
AddDlgItem(
	LPWSTR pwStr,
	DWORD style,
	WORD x, WORD y, WORD cx, WORD cy, WORD id,
	WORD cls,
	LPCSTR title)
{
	LPDLGITEMTEMPLATE pdit = (LPDLGITEMTEMPLATE)pwStr;
	pdit->style = style;
	pdit->dwExtendedStyle = 0;
	pdit->x = x;
	pdit->y = y;
	pdit->cx = cx;
	pdit->cy = cy;
	pdit->id = id;
	pwStr += sizeof(DLGITEMTEMPLATE) / sizeof(WORD);
	*pwStr++ = 0xFFFF;
	*pwStr++ = cls;
	pwStr += StringBuffer(title).toUnicode(pwStr);
	if ((((DWORD)pwStr) & 0x3) != 0) *pwStr++ = 0;
	return pwStr;
}

static HWND
CreateMainDialog(HINSTANCE hInst, LPARAM lParam)
{
	Array<BYTE> pTemplate(DLGTEMPLSIZE);
	LPDLGTEMPLATE pdt = (LPDLGTEMPLATE)(BYTE*)pTemplate;

	pdt->style = WS_POPUP | WS_CAPTION | WS_SYSMENU;
	pdt->dwExtendedStyle = 0;
	pdt->cdit = 10;
	pdt->x = 0;
	pdt->y = 0;
	pdt->cx = 229;
	pdt->cy = 109;
	LPWSTR pwStr = (LPWSTR)(pTemplate + sizeof(DLGTEMPLATE));
	*pwStr++ = 0; // no menu name
	pwStr += StringBuffer(pszClassName).toUnicode(pwStr);
	pwStr += StringBuffer(pszCaption).toUnicode(pwStr);
	*pwStr++ = 9;
	pwStr += StringBuffer(pszFontName).toUnicode(pwStr);
	if ((((DWORD)pwStr) & 0x3) != 0) *pwStr++ = 0;

	// OK button
	pwStr = AddDlgItem(pwStr,
						BS_DEFPUSHBUTTON | BS_PUSHBUTTON |
							WS_CHILD | WS_TABSTOP | WS_GROUP,
						57, 88, 50, 14, IDOK, 0x0080,
						pszOK);
	// Help button
	pwStr = AddDlgItem(pwStr,
						BS_PUSHBUTTON | WS_CHILD | WS_TABSTOP | WS_GROUP,
						114, 88, 50, 14, IDC_SHOWHELP, 0x0080,
						pszHelp);
	// Quit button
	pwStr = AddDlgItem(pwStr,
						BS_PUSHBUTTON | WS_CHILD | WS_TABSTOP | WS_GROUP,
						171, 88, 50, 14, IDC_CLOSE, 0x0080,
						pszQuit);
	// Title text
	pwStr = AddDlgItem(pwStr,
						WS_CHILD | WS_GROUP,
						33, 13, 108, 8, IDC_APPNAME, 0x0082,
						pszTitle);
	// Copyright text
	pwStr = AddDlgItem(pwStr,
						WS_CHILD | WS_GROUP,
						33, 23, 187, 8, IDC_STATIC, 0x0082,
						pszCopyRight);
	// Connect groupbox
	pwStr = AddDlgItem(pwStr,
						BS_GROUPBOX | WS_CHILD | WS_GROUP,
						7, 39, 215, 47, IDC_STATIC, 0x0080,
						pszLabelConnect);
	// Service title text
	pwStr = AddDlgItem(pwStr,
						WS_CHILD | WS_GROUP,
						13, 52, 41, 8, IDC_STATIC, 0x0082,
						pszLabelService);
	// Number title text
	pwStr = AddDlgItem(pwStr,
						WS_CHILD | WS_GROUP,
						26, 65, 28, 8, IDC_STATIC, 0x0082,
						pszLabelNumber);
	// Service text
	pwStr = AddDlgItem(pwStr,
						WS_CHILD | WS_GROUP,
						57, 52, 128, 8, IDC_SERVICENAME, 0x0082,
						"");
	// Number text
	pwStr = AddDlgItem(pwStr,
						WS_CHILD | WS_GROUP,
						57, 65, 128, 8, IDC_CONVNUM, 0x0082,
						"");

	HWND hDlg = ::CreateDialogIndirectParam(hInst,
											(LPCDLGTEMPLATE)pTemplate,
											NULL,
											(DLGPROC)MainWndProc,
											lParam);

	return hDlg;
}

#endif // __GNUC__

static void
CloseStdHandle(ULONG hStd)
{
	HANDLE hStdHandle;
	if ((hStdHandle = ::GetStdHandle(hStd)) != NULL) {
		::CloseHandle(hStdHandle);
		::SetStdHandle(hStd,NULL);
	}
}

int APIENTRY
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR lpszCmdLine,
	int nCmdShow)
{
	int	ret_code = 0;	//	^[R[h

	try {

	//	T[oi[NX̐
	Auto_Ptr<DDEServerInfo>	pDdeSI(new DDEServerInfo(hInstance));

	//	R}hC̉߁T[rXetc.̎擾
	if (!ParseCmdLine(*pDdeSI)) return 1;

	//	̃CX^X̋N}~邽 Mutex IuWFNg쐬B
	//	AAMutex ̖O͊{T[rXɌŗLȂ̂ŁA
	//	ʂ̊{T[rXCX^X͕NłB
	::SetLastError(0);
	HANDLE hMutex = ::CreateMutex(NULL,FALSE,pDdeSI->m_sbMutexName);
	if (::GetLastError() == ERROR_ALREADY_EXISTS) {
		HWND hwndPrev = ::FindWindow(GetServerString(SVR_STR_DSCLASSNAME),
									 pDdeSI->m_sbWndTitle);
		//	^XNgC̃ACȐԂύX
		if (hwndPrev != NULL) {
			::SendMessage(hwndPrev, WM_USER_SHOWICON, pDdeSI->m_bHideIcon, 0);
		}

		//	̃vZX͏I
		::CloseHandle(hMutex);

		return 0;
	}

	//	̏ȂƐevZXet@C
	//	_CNgĂꍇ DOS AvɋNȂB
	//	R̓C}C`悭ȂΏÖ@I
	//	c܂傤Ȃ낤(^^;B
	CloseStdHandle(STD_INPUT_HANDLE);
	CloseStdHandle(STD_OUTPUT_HANDLE);
	CloseStdHandle(STD_ERROR_HANDLE);

	//	RRg[Cȕ
	::InitCommonControls();

	//	((^^;)CEBhẼEBhENX̓o^
	WNDCLASS wc;
	::ZeroMemory(&wc, sizeof(WNDCLASS));
	wc.style = CS_CLASSDC|CS_DBLCLKS;
	wc.lpfnWndProc = (WNDPROC)DefDlgProc;	//	CEBhE
	wc.cbWndExtra = DLGWINDOWEXTRA;			//	_CAO
	wc.hInstance = hInstance;
	wc.hIcon = ::LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON));
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszClassName = GetServerString(SVR_STR_DSCLASSNAME);

	HWND hwndDlg;
	if (::RegisterClass(&wc) &&
#ifdef __GNUC__
		(hwndDlg = CreateMainDialog(hInstance, (LPARAM)pDdeSI.ptr()))) {
#else
		(hwndDlg = ::CreateDialogParam(hInstance,
										MAKEINTRESOURCE(IDD_ABOUT),
										NULL,
										(DLGPROC)MainWndProc,
										(LPARAM)pDdeSI.ptr()))) {
#endif
		//	܂񑩂̃bZ[W[v
		MSG msg;
		while (::GetMessage(&msg,NULL,0,0)) {
			DEBUG_OUTPUT(("Enter: msg=%08x,w=%08x,l=%08x", msg.message, msg.wParam, msg.lParam));
			//	CEBhE(_CAO)ւ̃bZ[Wz
			if (!::IsDialogMessage(hwndDlg,&msg)) {
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
			DEBUG_OUTPUT(("Leave: msg=%08x,w=%08x,l=%08x", msg.message, msg.wParam, msg.lParam));
		}
		ret_code = msg.wParam;
	} else {
		ErrorMessageBox(MSG_ERR_START);
		ret_code = 1;
	}

	//	n
	::CloseHandle(hMutex);

	} catch (...) {
		return -1;
	}

	return ret_code;
}

