// $Id: auto_ptr.h,v 1.2 2002/02/19 15:34:21 sugiura Exp $
/*
 *	auto_ptr.h
 *	X}[g|C^NX
 */

#ifndef	DENGAKUSERIES_CLASSES_AUTO_PTR
#define	DENGAKUSERIES_CLASSES_AUTO_PTR

#include <windows.h>

// złȂIuWFNgւ̃|C^X}[g|C^
template<class T>
class Auto_Ptr {
public:
	Auto_Ptr(T* ptr)	//	̃|C^󂯎ꍇ
		:	m_ptr(ptr),
			m_bOwner(TRUE)	//	|C^wIuWFNg폜ӔC
	{}
	Auto_Ptr(Auto_Ptr<T>& aptr)
		:	m_ptr(aptr.m_ptr),
			m_bOwner(aptr.m_bOwner)	//	I[i[tǑp
	{
		aptr.m_bOwner = FALSE;	//	 Auto_Ptr IuWFNg
								//	I[i[ł͂ȂȂ
	}
	~Auto_Ptr()
	{
		//	I[i[ł΃IuWFNg폜
		if (m_bOwner) delete m_ptr;
	}

	Auto_Ptr<T>& operator=(Auto_Ptr<T>& aptr)
	{
		//	I[i[ł΃IuWFNg폜
		if (m_bOwner) delete m_ptr;
		m_ptr = aptr.m_ptr;
		m_bOwner = aptr.m_bOwner;	//	I[i[tǑp
		aptr.m_bOwner = FALSE;	//	aptr ̓I[i[ł͂ȂȂ
		return *this;
	}
	Auto_Ptr<T>& operator=(T* ptr)
	{
		if (m_bOwner) delete m_ptr;
		m_ptr = ptr;
		m_bOwner = TRUE;
		return *this;
	}

	T& operator*() { return *m_ptr; }
	const T& operator*() const { return *m_ptr; }
	T* operator->() { return m_ptr; }
	const T* operator->() const { return m_ptr; }
	T* ptr() const { return m_ptr; }

private:
	T* m_ptr;		//	̃|C^
	BOOL m_bOwner;	//	I[i[tO
};

#endif
