//	$Id: dlgdata.h,v 1.19 2011/01/07 16:08:38 sugiura Exp $
/*
 *	dlgdata.h
 *	_CAONX
 */

/*
	_CAO̎ɂẴRgF

	SẴRg[EBhE DlgPage NXɑEBhE
	(q_CAO)̎qEBhEłBāASĂ̎q_CAO
	DlgFrame NXɑEBhE(e_CAO)̎qEBhEłB
	ȂAnewdialog(ex) ō쐬_CAO "root" ƂO
	q_CAOłB
*/

#ifndef	DENGAKUSERIES_CLASSES_DIALOG
#define	DENGAKUSERIES_CLASSES_DIALOG

#include "linklist.h"
#include "ctrlname.h"
#include "ThemeWrapper.h"

class SessionInstance;
class DlgPage;
class DlgFrame;
class CtrlListItem;
class DlgDataFile;

typedef struct {
	SessionInstance* m_psi;
	HWND m_hwndOwner;
	BOOL m_bOnTop;
} SHOWDLGPROCARGS, *LPSHOWDLGPROCARGS;

//	_CAÕtHgi[\
typedef struct FontProperty_tag	{
	int				m_fontsize;		//	|Cg
	StringBuffer	m_fontname;	//	tHg̃obt@
	FontProperty_tag() : m_fontsize(0), m_fontname(32) {}
} FontProperty, *LPFontProperty;

enum {
	DLGPOS_CLIENT_CENTER = 0,
	DLGPOS_SCREEN_CENTER = 1,
	DLGPOS_CLIENT_COORD  = 2,
	DLGPOS_SCREEN_COORD  = 3,
	DLGPOS_CARET_COORD   = 4,
	DLGPOS_CURSOR_COORD  = 5
};

// _CAO\ʒuw̒P
enum {
	DLGPOS_UNIT_FONTSIZE = 0,
	DLGPOS_UNIT_PIXEL    = 1
};

//	Rg[̃Xg
typedef	HashTable<CtrlListItem*,31>	CtrlHashTable;

//	_CAOۂɕ\ׂq_CAOo^L[̃ACe
class ShowPageQueueItem {
public:
	ShowPageQueueItem(DlgPage* pdp, HWND hwndCtrl,
					  WORD x, WORD y, WORD cx, WORD cy,
					  bool bInTabCtrl)
		:	m_pdp(pdp), m_hwndCtrl(hwndCtrl),
			m_x(x), m_y(y), m_cx(cx), m_cy(cy),
			m_bInTabCtrl(bInTabCtrl)
	{}
	DlgPage* m_pdp;
	HWND m_hwndCtrl;
	WORD m_x;
	WORD m_y;
	WORD m_cx;
	WORD m_cy;
	bool m_bInTabCtrl;
};

//	q_CAO\NX
class DlgPage {
public:
	DlgPage(DlgFrame *pdf, const StringBuffer &name, WORD width);
	~DlgPage();

//	ol̎擾
	const StringBuffer&	getName() const { return m_strName; }
	DlgFrame& getDlgFrame(){ return *m_pDlgFrame; }
	HWND gethwndPage() const { return m_hwndPage; }
	WORD getWidth() const { return m_width; }
	WORD getHeight() const { return m_height; }
	WORD getDefID() const;
	bool isInTabCtrl() const { return m_bInTabCtrl; }

	COLORREF	getBkColor() const
	{
		return m_hbkBrush != NULL ? m_crefBkColor : ::GetSysColor(COLOR_3DFACE);
	}
	HBRUSH	getBkBrush() const { return m_hbkBrush; }

//	_CAO̍\z/
	DWORD evalPageSize();	//	m_width, m_height vZ
	//	q_CAO̍\z
	HWND createPage(HWND, BYTE, WORD, WORD, WORD, WORD, bool, FontProperty&);
	BOOL initPage(HWND);	//	q_CAȌ
	BOOL uninitPage();	//	q_CAO̔j̏
	BOOL showPage(BOOL);	//	q_CAỎ
	BOOL enablePage(BOOL);	//	q_CAO̗L
	BOOL addShowPageQueue(LPCSTR pname, HWND hwndCtrl,
						  WORD x, WORD y, WORD cx, WORD cy,
						  bool bInTabCtrl);

//	Rg[̒ǉE擾
	int addCtrl(CtrlListItem*);	//	Rg[̒ǉ
	int addCtrl(int type, const StringBuffer& name, const StringBuffer& text);
	//	Rg[̎擾
	CtrlListItem* getCtrl(const StringBuffer& name = nullStr);
	CtrlListItem* prevCtrl(const CtrlListItem* pCtrl);
	CtrlListItem* nextCtrl(const CtrlListItem* pCtrl);
	HWND getFocusedCtrl();

//	bZ[Wnh
	WORD onCommand(WPARAM, LPARAM);
	WORD onNotify(WPARAM, LPARAM);
	WORD onHScroll(WPARAM, LPARAM);
	WORD onImeNotify(WPARAM, LPARAM);
	HBRUSH onCtlColor(UINT, WPARAM, LPARAM);

//	f[^̏݁Eǂݏo
	BOOL dumpData(DlgDataFile&);
	BOOL loadData(DlgDataFile&);

	int setExProperty(const StringBuffer& key, const StringBuffer& value);
	StringBuffer getExProperty(const StringBuffer& key);

	friend class DlgFrame;

private:
	DlgFrame* m_pDlgFrame;	//	e_CAOւ̃|C^
	const StringBuffer m_strName;	//	_CAOy[W
	HWND m_hwndPage;		//	EBhEnh
	DWORD m_dwPageSize;	//	DLGTEMPLATE ̑傫
	LinkList<CtrlListItem>* m_pCtrlList;	//	Rg[̃Xg
	CtrlHashTable* m_pHashCtrl;	//	Rg[̃Xg
	CtrlListItem* m_pCurCtrlData;	//	ΏۂƂȂRg[ւ̃|C^
	LinkList<ShowPageQueueItem>* m_pShowPageQueue;
	BOOL m_bVisible;	//	EBhEǂ
	BOOL m_bEnable;		//	EBhELǂ
	WORD m_cdit;		//	ۂ̃Rg[
						//	(!=m_pCtrlList->itemNum() ɒ!!)
	WORD m_iniwidth;	//	_CAȌ
	WORD m_width;		//	_CAO̕
	WORD m_height;		//	_CAO̍
	bool m_bInTabCtrl;  //  Tab Rg[̓ɕ\邩ǂ
	COLORREF	m_crefBkColor;	//	wiFݒ
	HBRUSH		m_hbkBrush;	//	wiFuVnh
};

//	Rg[Rg[ʂhc߂nbVe[u
typedef HashTable<int,61> CtrlIdHashTable;

//	e_CAO\NX
class DlgFrame {
public:
	DlgFrame();
	~DlgFrame();

	void setSessionInstance(SessionInstance* psi)
	{
		m_pSessionInstance = psi;
	}
	SessionInstance* getSessionInstance() const { return m_pSessionInstance; }

	void setNotify(const StringBuffer& newvalue);	//	notify code ̒ʒm
	BOOL getNotify(StringBuffer& buf, DWORD wait) const;
	void resetNotify();

	void setDialogClosed()
	{
		m_bAlreadyClosed = TRUE;
	}

//	ol̎擾EύX
	HWND getUserDlg() const { return m_hwndFrame; }
	const StringBuffer&	getDlgTitle() const { return m_DlgTitle; }
	void setDlgTitle(const StringBuffer& title)
	{
		m_DlgTitle = title;
		if (::IsWindow(m_hwndFrame)) ::SetWindowText(m_hwndFrame,m_DlgTitle);
	}
	void setFrameProperty(
					const StringBuffer& title,
					POINTS* ppt = NULL,
					WORD wflags = 0,
					const StringBuffer& fontname = nullStr,
					WORD fontsize = 0,
					WORD wPosUnit = DLGPOS_UNIT_FONTSIZE
				);
	const StringBuffer& getFontName() const
	{
		return m_pFontProp->m_fontname;
	}
	int getFontSize() const
	{
		return m_pFontProp->m_fontsize;
	}
	WORD getDefID() const;

	POINTS getDlgPos() const;
	void setDlgPos(const POINTS& pos, WORD wOrigin, WORD wPosUnit);

	COLORREF	getBkColor() const
	{
		return m_hbkBrush != NULL ? m_crefBkColor : ::GetSysColor(COLOR_3DFACE);
	}
	HBRUSH	getBkBrush() const { return m_hbkBrush; }

//	_CAO̍\zEEj
	HWND createFrame(HWND hwndOwner, BOOL bOnTop = FALSE); // _CAO̍\z
	BOOL showFrame();	//	_CAO̕\
	BOOL closeFrame();	//	_CAO̔j
	void resetFrame();	//	_CAOf[^̍ď
	BOOL initFrame(HWND);	//	_CAȌ(WM_INITDIALOG nh)
	BOOL uninitFrame();	//	_CAO̔j

//	q_CAO̒ǉE擾E쐬
	int addPage(const StringBuffer&, WORD);	//	q_CAO̒ǉ
	BOOL setCurrentPage(const StringBuffer&); // ǉΏۂ̎q_CAO̕ύX
	DlgPage* getPage(const StringBuffer& name = nullStr) // q_CAO̎擾
	{
		return (name.length() > 0) ?
			m_pPageList->getItemByName(name) : m_pCurDlgPage;
	}
	DlgPage* getPage(int index)	//	q_CAO̎擾
	{
		return m_pPageList->getItemByIndex(index);
	}
	HWND createPage(
					const StringBuffer& name,
					HWND hWnd,
					WORD ofx, WORD ofy, WORD cx, WORD cy,
					bool bInTabCtrl
				);	//	q_CAÕEBhE쐬

//	Rg[̎擾
	CtrlListItem* getCtrl(const StringBuffer& ctrlname = nullStr,
						const StringBuffer& pagename = nullStr) const;

//	tH[JX(Ă)Rg[
	int setFocusedCtrl(const StringBuffer& name);
	int setFocusedCtrl();	//	m_sbFocusedCtrlɃtH[JXړ
	const StringBuffer& getFocusedCtrl() const;

	// ɃtH[JX𓾂Rg[̖OԂ\bh
	const StringBuffer& getFocusedCtrlName() const
	{
		return m_sbFocusedCtrl;
	}

	int setImeState(int nState);
	int getImeState() const
	{
		return m_imestate;
	}
	void setImeAlreadyFocused()
	{
		m_bAlreadyFocused = TRUE;
	}
	BOOL isImeAlreadyFocused() const
	{
		return m_bAlreadyFocused;
	}

	//	Rg[̃tH[JX𓾂鍀ڂw聕擾
	int setCtrlFocusedItem(const StringBuffer& ctrl, const StringBuffer& item);
	StringBuffer getCtrlFocusedItem(const StringBuffer& ctrl) const;

	void enableTheme(HWND hwndDlg, BOOL bEnable)
	{
		if (m_pThemeWrapper) {
			LPCWSTR	pszParam = bEnable ? NULL : L" ";
			m_pThemeWrapper->SetWindowTheme(hwndDlg, pszParam, pszParam);
		}
	}

	void enableThemeDialogTexture(HWND hwndDlg, DWORD dwFlags)
	{
		if (m_pThemeWrapper) {
			m_pThemeWrapper->EnableThemeDialogTexture(hwndDlg, dwFlags);
		}
	}

//	_CAO̔wiTABRg[ƓFɂ
	void setBackGroundTheme(HWND hwndPage, BOOL bInTab)
	{
		enableThemeDialogTexture(hwndPage, bInTab ? ETDT_ENABLETAB : ETDT_ENABLE);
	}
	void drawThemeParentBackground(HWND hwndCtrl, HDC hDC, const RECT* pRect)
	{
		if (m_pThemeWrapper) {
			m_pThemeWrapper->DrawThemeParentBackground(hwndCtrl, hDC, pRect);
		}
	}
	void setWindowTheme(HWND hwndCtrl)
	{
		enableTheme(hwndCtrl, TRUE);
	}
	BOOL getThemeColor(HWND hwndPage, LPCWSTR pwszClass, int iPart, int iState, int iProp, COLORREF* pCRef)
	{
		if (!m_pThemeWrapper) return FALSE;
		HTHEME hTheme = m_pThemeWrapper->OpenThemeData(hwndPage, pwszClass);
		if (!hTheme) {
//			::MessageBox(NULL, "hTheme == NULL", NULL, MB_OK);
			return FALSE;
		}
		HRESULT hr = m_pThemeWrapper->GetThemeColor(hTheme, iPart, iState, iProp, pCRef);
		m_pThemeWrapper->CloseThemeData(hTheme);
		return hr == S_OK;
	}
	BOOL isThemeActive()
	{
		if (!m_pThemeWrapper) return FALSE;
		return m_pThemeWrapper->IsThemeActive();
	}

//	f[^̏݁EǍ
	BOOL dumpData(DlgDataFile&);
	BOOL loadData(DlgDataFile&);

	int setExProperty(const StringBuffer& key, const StringBuffer& value);
	StringBuffer getExProperty(const StringBuffer& key);

private:
	SessionInstance* m_pSessionInstance; // ZbVCX^Xւ̃|C^
	CtrlIdHashTable	m_HashCtrl; // Rg[hc
	HWND m_hwndFrame;	//	EBhEnh
	ThemeWrapper* m_pThemeWrapper;
	NamedLinkList<DlgPage>* m_pPageList;	//	q_CAÕXg
	DlgPage* m_pCurDlgPage;	//	ݏΏۂ̎q_CAO
	StringBuffer m_DlgTitle;	//	_CAÕ^Cg
	StringBuffer m_sbFocusedCtrl; // tH[JX𓾂Rg[
	LPFontProperty m_pFontProp;	//	_CAÕtHg
	POINTS m_pos;	//	_CAO̕\ʒu
	WORD m_wPosUnit;	// m_pos o̒P
	WORD m_width;	//	_CAO̕
	WORD m_height;	//	_CAO̍
	WORD m_flags;	//	\ʒuɊւtO
	int m_imestate;	//	IMȄԂ\
	BOOL m_bAlreadyFocused; // ̓tH[JXꂩ̃Rg[ɃtH[JXڂǂ
	BOOL m_bAlreadyClosed;	// WM_CLOSEςǂiVista΍j
	COLORREF	m_crefBkColor;	//	wiFݒ
	HBRUSH		m_hbkBrush;	//	wiFuVnh
};

extern const StringBuffer strRootPageName;
extern const StringBuffer okStr;
extern const StringBuffer ngStr;

#endif
