//	$Id: env_var.h,v 1.1.1.1 2001/10/07 14:41:22 sugiura Exp $
/*
 *	env_var.h
 *	ϐ̊ǗɊւNX
 */

#ifndef DENGAKUSERIES_CLASSES_ENV_VAR
#define DENGAKUSERIES_CLASSES_ENV_VAR

#include "smalloc.h"

//	L̃TCY(bytes)
#define ENV_PAGESIZE (512*1024)
//	iIϐۑ郌WXgL[
#define ENV_REGKEY_NAME_ROOT "Software\\Sugi_Macro\\DengakuSeries\\Env"

//	ϐ̖OAlǗ邽߂̍\
//	łu|C^vƂ́ASMAlloc NXŊǗ鋤L݂̂
//	Lȑ΃AhXi[ϐwB
#pragma pack(push,env_header,4)
typedef struct {
	UINT m_pNextHeader;	//	̕ϐ ENV_HEADER \̂ւ̃|C^
	UINT m_pEnvName;	//	ϐւ̃|C^
	UINT m_pEnvString;	//	ϐlւ̃|C^
} ENV_HEADER, *LPENV_HEADER;
#pragma pack(pop,env_header)

class EnvManager {
public:
	EnvManager(const StringBuffer& env_name);
	~EnvManager();

	int count();	//	LԂ

	//	ϐ̎QƁE`Ejs\bh
	StringBuffer read(const StringBuffer& env_name);
	void write(const StringBuffer& env_name, const StringBuffer& env_var);
	void del(const StringBuffer& env_name);
	//	ϐ݂邩ǂԂ
	BOOL exist(const StringBuffer& env_name);
	//	ݒ`Ăϐ̕ϐSāuȂ߂v߂̃\bh
	void enum_env();	//	
	StringBuffer next_env();	//	̕ϐo
	BOOL hasmore_env();	//	܂cĂϐ邩Ԃ

private:
	StringBuffer m_env_name;	//	L̖O
	SMAlloc* m_psma;	//	}bsOIuWFNg̃ǗNX
	UINT m_enumindex;	//	next_env() ŕԂϐ
						//	ENV_HEADER ւ(SMAlloc ̈Ӗ)|C^

	BOOL loadEnv();		//	iIϐ̓Ǎ݂s
	BOOL saveEnv();		//	iIϐ̕ۑs

	EnvManager(const EnvManager&);
	EnvManager& operator=(const EnvManager&);
};

#endif

