//	$Id: optmap.h,v 1.1 2002/04/17 16:23:31 sugiura Exp $
/*
 *	optmap.h
 *	IvVƑΉtOlǗNX
 */

#ifndef DENGAKUSERIES_CLASSES_OPTMAP
#define DENGAKUSERIES_CLASSES_OPTMAP

#include "strbuf.h"
#include "array.h"

#define OPT_INVALID  ((DWORD)-1)

// IvVƑΉtOlǗNX
class OptMap {
public:
	// opts  : IvV̕
	// flags : opts ̕ɑΉtOl̔zւ̃|C^
	//         vf͍Œ opts.length() Kv
	OptMap(const StringBuffer& opts, DWORD* flags)
		: m_opts(opts),
		  m_flags(opts.length())
	{
		m_flags.copy(0, flags, m_opts.length());
	}

	//  ch ɑΉtOlԂ
	DWORD getFlag(TCHAR ch) const
	{
		int idx = m_opts.find(ch);
		return (idx >= 0) ? m_flags[idx] : OPT_INVALID;
	}

private:
	const StringBuffer m_opts;
	Array<DWORD> m_flags;
};

// ftHgIvV`
extern OptMap defOptMap;

// omap ɊÂăIvV͂֐
// P̍ŏ͖̕ɖ(IvVwqƂ݂Ȃ)
BOOL GetFlags(const StringBuffer&, DWORD&, const OptMap& omap = defOptMap);

#endif
