//	$Id: session.cpp,v 1.7 2008/06/29 15:19:43 sugiura Exp $
/*
 *	session.cpp
 *	SessionInstance NX̃RA̎
 */

#include "session.h"

SessionInstance::SessionInstance(HINSTANCE hInstance, BOOL bTrueCD)
	:	m_hInstance(hInstance),	//	CX^Xnh
		m_dwLastError(0L), // DdeExecute()  LastError
		m_DirList(bTrueCD), // DirList NX
		m_pSPIManager(NULL), // SPI_Manager NXւ̃|C^
		m_pEnvManager(NULL), // EnvManager NXւ̃|C^
		m_pFileOpResult(NULL), // t@Cn֐̌ʂێNXւ̃|C^
		m_pEnumerator(NULL), // enum* ̌ʂێNXւ̃|C^
		m_pStrToken(NULL), // gettoken ̌ʂێNXւ̃|C^
		m_pMenuThread(NULL), // j[\Xbhւ̃|C^
		m_pDlgThread(NULL), // _CAO\Xbhւ̃|C^
		m_pBRegExp_Manager(NULL),
		m_pHmJre_Manager(NULL)
{
	m_DlgFrame.setSessionInstance(this);

	DWORD dwVersion = GetVersionInfo(hInstance);

	TCHAR buf[16];
	wsprintf(buf, "%d.%d%d%s", (BYTE)(dwVersion >> 24), (BYTE)(dwVersion >> 16), (BYTE)(dwVersion >> 8),
#ifndef	_WIN64
			(BYTE)dwVersion == 0 ? "" : "b");
#else
			(BYTE)dwVersion == 0 ? "(x64)" : "b(x64)");
#endif
	m_strVersion = buf;
}

SessionInstance::~SessionInstance()
{
	//	prevent thread stop before closing window
	if (m_pMenuThread.ptr() != NULL) this->stopMenuThread();
	if (m_pDlgThread.ptr() != NULL) this->si_enddialog(0); // no wait
}

