//	$Id: str_tbl.h,v 1.8 2007/04/04 17:04:32 sugiura Exp $
/*
 *	str_tbl.h
 *	e[u̒`
 */

#ifndef	DENGAKUSERIES_FUNC_STR_TBL
#define	DENGAKUSERIES_FUNC_STR_TBL

#include "strbuf.h"

#define	WM_USER_SHOWUSERMENU	(WM_USER+1001)
#define	WM_USER_SHOWUSERDLG		(WM_USER+1002)
#define	WM_USER_MESSAGEBOX		(WM_USER+1003)
#define	WM_USER_QUESTIONBOX		(WM_USER+1004)
#define	WM_USER_NOTIFY			(WM_USER+1005)
#define WM_USER_GETFOCUSEDCTRL  (WM_USER+1006)
#define	WM_USER_SETFOCUSEDCTRL	(WM_USER+1007)
#define WM_USER_MAX				(WM_USER_SETFOCUSEDCTRL + 1)

enum StrTableIndex {
	STR_UNKNOWNSTR = 0,
	STR_VERSION,
	STR_USRMSGBOX_MESSAGE,
	STR_USRMSGBOX_QUESTION,
	STR_DLGDATA_DLGFRAMEPROPERTY,
	STR_DLGDATA_TITLE,
	STR_DLGDATA_FONTSIZE,
	STR_DLGDATA_FONTNAME,
	STR_DLGDATA_PLACEX,
	STR_DLGDATA_PLACEY,
	STR_DLGDATA_WIDTH,
	STR_DLGDATA_FLAGS,
	STR_DLGDATA_PAGENAME,
	STR_DLGDATA_PAGENUM,
	STR_DLGDATA_DLGPAGEPROPERTY,
	STR_DLGDATA_ENABLE,
	STR_DLGDATA_CTRLNUM,
	STR_DLGDATA_CTRLPROPERTY,
	STR_DLGDATA_TYPE,
	STR_DLGDATA_NAME,
	STR_DLGDATA_TEXT,
	STR_DLGDATA_ITEMNUM,
	STR_DLGDATA_CHILD,
	STR_DLGDATA_INTERNALCTRLNUM,
	STR_DLGDATA_NOTIFY,
	STR_DLGDATA_HEIGHT,
	STR_DLGDATA_CTRL,
	STR_DLGDATA_ID,
	STR_DLGDATA_STYLE,
	STR_DLGDATA_EXSTYLE,
	STR_DLGDATA_FONT,
	STR_DLGDATA_COLOR,
	STR_DLGDATA_FACE,
	STR_DLGDATA_STATE,
	STR_DLGDATA_MIN,
	STR_DLGDATA_MAX,
	STR_DLGDATA_VAL,
	STR_DLGDATA_TIC,
	STR_DLGDATA_ITEM,
	STR_DLGDATA_COLNUM,
	STR_DLGDATA_USEHEADER,
	STR_DLGDATA_HEADER,
	STR_DLGDATA_ROOT,
	STR_DLGDATA_OK,
	STR_DLGDATA_CANCEL,
	STR_DLGDATA_REFBUTTON,
	STR_DLGDATA_VERSION,
	STR_DLGDATA_COMMONPROPERTY,
	STR_DLGDATA_USERSIGNATURE,
	STR_DLGDATA_STATES,
	STR_DLGDATA_IMESTATE,
	STR_DLGDATA_SORT,
	STR_DLGDATA_EDITABLE,
	STR_COLORTBL_SECTION,
	STR_LAST
};

extern	LPCSTR	const_strings[];

inline LPCSTR
GetString(StrTableIndex resid)
{
	return const_strings[(resid < STR_LAST) ? resid : STR_UNKNOWNSTR];
}

#endif
