//	$Id: ms_func.cpp,v 1.7 2006/03/16 14:46:56 sugiura Exp $
/*
 *	ms_func.cpp
 *	j[\֐
 */

#include "DengakuDLL.h"

static HWND
GetActualHavingCaretWindow(HWND hWndHavingCaretCandidate)
{
	OSVERSIONINFO osi;
	osi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (!::GetVersionEx(&osi)) {
		return hWndHavingCaretCandidate;
	}

	switch (osi.dwPlatformId) {
	case VER_PLATFORM_WIN32_NT:
		// WinNT4.0SP3ȍ~
		{
			int len = lstrlen(osi.szCSDVersion);
			if (osi.dwMajorVersion < 4 ||
				osi.dwMajorVersion == 4 && (len == 0 || osi.szCSDVersion[len - 1] < '3')) {
				return hWndHavingCaretCandidate;
			}
		}
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		// Win98ȍ~
		if (osi.dwMinorVersion == 0) {
			return hWndHavingCaretCandidate;
		}
		break;
	default:
		return hWndHavingCaretCandidate;
	}

	DWORD dwThreadID = ::GetWindowThreadProcessId(hWndHavingCaretCandidate, NULL);

	GUITHREADINFO guiInfo;
	guiInfo.cbSize = sizeof(guiInfo);
	if (::GetGUIThreadInfo(dwThreadID, &guiInfo) &&
		guiInfo.hwndCaret != NULL) {
		return guiInfo.hwndCaret;
	}

	return hWndHavingCaretCandidate;
}

static LPCSTR
show_menu(LPCSTR menuname, HIDEDLL_NUMTYPE hWndHavingCaret,
		  HIDEDLL_NUMTYPE x_offset, HIDEDLL_NUMTYPE y_offset)
{
	try {
		POINT pt;
		if (hWndHavingCaret != 0) {
			// Lbgʒu
			::GetCaretPos(&pt);
			HWND hWndActualHavingCaret = GetActualHavingCaretWindow((HWND)hWndHavingCaret);
			::ClientToScreen(hWndActualHavingCaret, &pt);
			pt.x += x_offset;
			pt.y += y_offset;
		} else {
			// }EXJ[\ʒu(}EXJ[\ʒu͌Ŏ擾)
			pt.x = x_offset;
			pt.y = y_offset;
		}

		//	showMenuThread() łR[h邪A
		//	ĂȂ悤Ȃ̂łɂ...ŁH
		HWND hwndTop = ::GetForegroundWindow();
		if (hwndTop != NULL) ::UpdateWindow(hwndTop);

		//	j[\Xbh̊Jn
		//	j[̕\ʃXbh̃EBhEɔC闝RF
		//	j̃XbhŃj[\
		//		Gۂ̃EBhENbN_
		//		u}NI܂HvƂłB
		//		͓EBhEĩXbhŁj쐬ĂlB
		//		}N쒆̏Gۂ̓bZ[W[v(DispatchMessage ɓnO)
		//		WM_LBUTTONDOWN tbNĂ̂ƎvB
		if (!g_pSessionInstance->showMenuThread(menuname,
												hWndHavingCaret == 0,
												pt)) {
			return errorStr;
		}

		//	Xbh~܂ő҂
		g_pSessionInstance->waitMenuThread();

		//	Ԃl̎擾
		g_strBuffer = nullStr;
		g_pSessionInstance->getNotify(g_strBuffer,INFINITE);

		//	Xbh̔j
		g_pSessionInstance->stopMenuThread();

		if (hwndTop != NULL) ::SetForegroundWindow(hwndTop);

		return g_strBuffer;

	} catch (...) {
		return "";
	}
}

//	|bvAbvj[\IʂԂ
DENGAKUDLL_API LPCSTR
MENU(LPCSTR menuname, HIDEDLL_NUMTYPE hWndHavingCaret)
{
	return show_menu(menuname, hWndHavingCaret, 0, 0);
}

//	|bvAbvj[\IʂԂ
DENGAKUDLL_API LPCSTR
MENUEX(LPCSTR menuname, HIDEDLL_NUMTYPE hWndHavingCaret,
	   HIDEDLL_NUMTYPE x_offset, HIDEDLL_NUMTYPE y_offset)
{
	return show_menu(menuname, hWndHavingCaret, x_offset, y_offset);
}

//	VKj[̍\z
DENGAKUDLL_API HIDEDLL_NUMTYPE
NEWMENU(LPCSTR menuname)
{
	try {
		return g_pSessionInstance->si_newmenu(menuname,TRUE);
	} catch (...) {
//		::MessageBox(NULL, "some exception occured.", NULL, MB_OK);
		return 0;
	}
}

//	j[ڂ̒ǉ(l)
DENGAKUDLL_API HIDEDLL_NUMTYPE
ADDMENUITEMEX(LPCSTR menuname, LPCSTR title, LPCSTR name, LPCSTR opt)
{
	try {
		return g_pSessionInstance->si_addmenuitem(menuname,title,name,opt);
	} catch (...) {
		return 0;
	}
}

//	j[ڂ̒ǉ(lȂ)
DENGAKUDLL_API HIDEDLL_NUMTYPE
ADDMENUITEM(LPCSTR menuname, LPCSTR title, LPCSTR name)
{
	try {
		return g_pSessionInstance->si_addmenuitem(menuname,title,name,nullStr);
	} catch (...) {
		return 0;
	}
}

//	j[ڂ̕ύX(l)
DENGAKUDLL_API HIDEDLL_NUMTYPE
CHANGEMENUITEMEX(LPCSTR name, HIDEDLL_NUMTYPE index, LPCSTR str, LPCSTR opt)
{
	try {
		return g_pSessionInstance->si_changemenuitem(name,index,str,opt);
	} catch (...) {
		return 0;
	}
}

//	j[ڂ̕ύX(lȂ)
DENGAKUDLL_API HIDEDLL_NUMTYPE
CHANGEMENUITEM(LPCSTR name, HIDEDLL_NUMTYPE index, LPCSTR str)
{
	try {
		return g_pSessionInstance->si_changemenuitem(name,index,str,nullStr);
	} catch (...) {
		return 0;
	}
}

//	j[ڂ폜
DENGAKUDLL_API HIDEDLL_NUMTYPE
DELETEMENUITEM(LPCSTR menuname, HIDEDLL_NUMTYPE index)
{
	try {
		return g_pSessionInstance->si_deletemenuitem(menuname,index);
	} catch (...) {
		return 0;
	}
}

