// $Id: convdata.h,v 1.2 2002/02/20 16:48:40 sugiura Exp $
/*
 *	convdata.h
 *	DDE ʐMɗpӂ郊\[XǗƃR}hsNX̒`
 */

#ifndef DENGAKUSERVER_CLASSES_CONVDATA
#define DENGAKUSERVER_CLASSES_CONVDATA

#include "session.h"
#include "ddeobjs.h"
#include "opencomdlg.h"

class ConvData;
class CmdLineParser;

//	DDE R}h ConvData::On_??() ւ̃|C^
typedef	int (ConvData::*PFNDDECMD_EXECUTE)(CmdLineParser&);
typedef StringBuffer (ConvData::*PFNDDECMD_REQUEST)(CmdLineParser&);
typedef PFNDDECMD_EXECUTE PFNDDECMD_POKE;

// X DDE ʐMNX
class ConvData : public SessionInstance {
public:
	ConvData(HINSTANCE, DWORD, HCONV, const StringBuffer&);
	~ConvData();

	//	o擾\bh
	HCONV gethConv() const { return m_hConv; }
	void sethConv(HCONV hconv) { m_hConv = hconv; }

	const DdeString& getAdvTopicName() const { return m_dsAdvTopicName; }
	const DdeString& setAdvTopicName(HSZ hszTopicName)
	{
		return (m_dsAdvTopicName = DdeString(m_ddeInst,hszTopicName));
	}
	const DdeString& getAdvItemName() const { return m_dsAdvItemName; }

	//	IuWFNg̎̐
	BOOL isKeepAlive() const { return m_sbKeepName.length() > 0; }
	const StringBuffer&	getKeepName() const { return m_sbKeepName; }
	void setKeepName(const StringBuffer &kn) { m_sbKeepName = kn; }

	//	AhoCX[v
	HDDEDATA ddeAdvStart(HSZ, HSZ);
	HDDEDATA ddeAdvStop(HSZ, HSZ);
	HDDEDATA ddeAdvReq(HSZ, HSZ);

	void setNotify(const StringBuffer&);

	//	R}hs
	HDDEDATA ddeExecute(PFNDDECMD_EXECUTE, CmdLineParser&);
	HDDEDATA ddeRequest(PFNDDECMD_REQUEST, CmdLineParser&, const DdeString&);
	HDDEDATA ddePoke(PFNDDECMD_POKE, CmdLineParser&);

	//	R}hnh
#define	DECLARE_DDECMD_HEADER
#define	DECLARE_DDECMD_EXECUTE(name) int On_##name (CmdLineParser&);
#define	DECLARE_DDECMD_REQUEST(name) StringBuffer On_##name (CmdLineParser&);
#define	DECLARE_DDECMD_POKE(name)    int On_##name (CmdLineParser&);
#define	DECLARE_DDECMD_FINAL
#define	DECLARE_DDECMD_FOOTER
#include "cmd.h"
#undef	DECLARE_DDECMD_HEADER
#undef	DECLARE_DDECMD_EXECUTE
#undef	DECLARE_DDECMD_REQUEST
#undef	DECLARE_DDECMD_POKE
#undef	DECLARE_DDECMD_FINAL
#undef	DECLARE_DDECMD_FOOTER

private:
	DWORD m_ddeInst; //	DDE T[õCX^Xnh
	HCONV m_hConv; // ʐMnh
	StringBuffer m_sbKeepName; // KeepAlive ̃IuWFNgʖ
	DdeString m_dsAdvTopicName; // AhoCX[ṽgsbN
	DdeString m_dsAdvItemName; // AhoCX[ṽACe
	HANDLE m_hAdvEvent;	// AhoCXf[^̃ANZX
						// CxgIuWFNg̃nh
	DWORD m_dwLastError; //	Ō Execute R}h̃G[l

	Auto_Ptr<Thread> m_pComDlgThread; // R_CAO\Xbh

	ConvData(const ConvData&);
	ConvData& operator=(const ConvData&);

	int do_opencomdlg(CmdLineParser&, PFNOPENCOMDLGPROC);
};

// R_CAOAj[̐eEBhE̍쐬R}hs
BOOL CreateDummyDlg(DLGPROC, LONG, WPARAM, LPARAM);

#endif

